#ifndef __ADC_H__
#define __ADC_H__

#include "jhl_defs.h"

void ADC_Init();
void ADC_Start();
void ADC_Stop();

void callbk_int_ad(); 
void set_batt_th();

void tsk_adc();
// tsk_adc̈A
u16  getVBatt();
u8   set_reg_power_info();

void chk_extension();
void chk_obs_pmic_batt_low();
void chk_irq0_batt();

void tsk_adc_calib();

enum BATT_TYPE{
  BATT_CO  = 0x00,
  BATT_PSS = 0x70,
  BATT_IS  = 0x30
};

#endif

