#pragma interrupt INTIIC0 MD_INTIIC0
#define ignore_NAK 0

#include "macrodriver.h"
#include "I2C.h"
#include "user_define.h"
#include "jhl_defs.h"
#include "vreg.h"
#include "I2C_selfprog.h"

#include "wdt.h"

extern u8 vregs[];
#include "PMIC_TWL2.h"




extern bit self_prog_mode;

/*****************************************************************************
  ჌x?
 *****************************************************************************/
volatile UCHAR	gIic0SlaveStatusFlag;



/*****************************************************************************
  vgRwH
 *****************************************************************************/
extern UCHAR vregs[];
UCHAR i2c_Send_start_addr;
UCHAR i2c_accessRegAdr;

u8    vreg_adrs;
u8    rcvd_buff;

u8    pre_dat;


// I@̓}NȂ̂ŁAreturn̓C[vɖ߂܂B
#define wait_next {                                        \
      while( IICIF0 != 1 ){                                \
        if( SPD0 ){                                        \
          LREL0 = 1;                                       \
          return;                                          \
        }                                                  \
      }                                                    \
}


__interrupt void MD_INTIIC0( void ){
  WREL0 = 1;                  // EFCgĎ̃oCg҂
  // tOP    X[uAhX,R/W
  if( COI0 != 1 ){              // ĂяoH
    LREL0 = 1;                  // Ă΂ꂽ̂͑ID
    return;
  }else{
//    ACKE0 = 1;                  // ackԂ悤ɂ
//    WREL0 = 1;                  // EFCgĎ̃oCg҂
  }

  wait_next;                    // PoCgM҂

  // Q           R/W WX^AhX
  WREL0 = 1;
  IICIF0 = 0;
  vreg_adrs = adrs_table_ext2int( IIC0 );

  // R
  // X^[gRfBVAf[^MtO҂

  while( 1 ){
    if( IICIF0 == 1 ){
      // M //
      IICIF0 = 0;
      WREL0 = 1;
      
      if( ( IIC0 == 0x4A ) && ( vreg_adrs == REG_INT_ADRS_TEMP7 ) ){
        // ȃvO[h //
        // ŕ͔ȂC܂...
        vregs[ REG_INT_ADRS_MODE ] = 0x00; // dItԂZ񂪂߁B
        PM_set_VRSET();
        self_programming();
        // AĂ܂
      }else{
        // ʏANZX(Cg) //
        LREL0 = 1;
        debug_led_on;
        vregs_write( vreg_adrs, IIC0 );
        debug_led_off;
        return;               // M܂ //
      }
    }else if( STD0 ){
      // M // (X^[gRfBVo)
      pre_dat = vregs_read( vreg_adrs );    // mcuAhXnBoCgڂ̏ IIc0ɏނƃEFCg

      // ǂRŌĂ΂̂҂
      wait_next;
      IICIF0 = 0;
      if( COI0 != 1 ){              // ĂяoH
        LREL0 = 1;                  // Ă΂ꂽ̂͑IDiHj
        return;
      }
      IIC0 = pre_dat;             // f[^𑗂
    
      wait_next;
      // SځB(Mf[^́AACK/NACK)@ǂĂĂ܂B
      IICIF0 = 0;                 // ܂
      LREL0 = 1;
      return;
    }else if( SPD0 ){             // I
      LREL0 = 1;
      return;
    }
  }
}




/*****************************************************************************
  {API
 *****************************************************************************/
void IIC0_Init( void )
{
  IICE0 =  0;                   /* IIC0 disable */

  IICMK0 = 1;                   /* INTIIC0 disable */
  IICIF0 = 0;                   /* clear INTIIC0 interrupt flag */

  IICPR0 = 0;                   /* set INTIIC0 high priority */

  PM6 &= ~0x1;                  /* set clock pin for IIC0 */
  P6 &= ~0x1;

  PM6 &= ~0x2;                  /* set data transfer I/O pin for IIC0 */
  P6 &= ~0x2;

  IICCL0 = IICCL0_INITIALVALUE | IIC0_CLOCK4;    // WX^A[h
  IICX0 = IIC0_EXPENSION0;                       //                 V
  SVA0 = IIC0_SLAVEADDRESS;
  STCEN = 1;                                     // X^[g̋
  IICRSV = 1;                                    // ʐM\Ȃ:X[uɓO

  SPIE0 = 0;                                     // XgbvRfBVł̊荞݂֎~
  WTIM0 = 1;                                     // ACKԂclkLɌŒ肷
  ACKE0 = 1;                                     //  _CPU͖Ď̒ʐM͂߂邩ȂőclkJȂƂȂ
  IICMK0 = 0;                                    // 荞݂

  IICE0 = 1;
}


//****************************************************************************
void IIC0_Stop( void ){
  IICE0 = 0;	/* IIC0 disable */
}



void IIC0_SlaveReceiveStart(){
  gIic0SlaveStatusFlag = 0;
  IICE0 = 1;
  LREL0 = 1;
  return;
}





