/*****************************************************************************
   TWL }CR
    de JHL cJZ
    nintendo
    '07 Jun., '07 Dec.

d
   *{[
   *Zbg
   *J LED
   *d LED
   *WiFi LED
   *CPUƂI2CʐM
******************************************************************************/
#include "incs.h"


void reg_init();

void running_immediately();
void running();
void tsk_sw_vol();              // tsk_`@cCxg[vŌĂ΂
void tsk_sw_pow();
void tsk_command_exec();
void wait_for_system_boot();

void save_BL_param();



//*****************************************************************************
// ^XÑC^[opJE^Aʑ      C^[o͂ɂ悤H (1P5ms)
u8 tsk_interval_cnt_adc       = 0,   tsk_interval_adc      = 200/25;      // 200/x  x[Hz]
u8 tsk_interval_cnt_power_led = 0,   tsk_interval_power_led;
u8 tsk_interval_cnt_sw_vol    = 0,   tsk_interval_sw_vol;
u8 tsk_interval_cnt_wifi_led  = 0,   tsk_interval_wifi_led =  10;
u8 tsk_interval_cnt_cam_led   = 0,   tsk_interval_cam_led  = 160;         // T = 0.8s 

bit adc_calib_mode;
bit flg_interval;
bit system_inited;
bit vol_mute_start;

bit rsv_set_vol;
bit rsv_set_BL;
bit rsv_set_PMIC_VRSET;
bit rsv_set_camLED;
bit rsv_set_batt_th;
bit rsv_set_powLED;

extern bit eeprom_bl_dirty;

extern u8 battLvl;

extern u8 vregs[];

sleep_status_ sleep_status = Wake;

static u8 pwsw_state = 3;       // XCb`̂߂̂́BO[ołȂƍ

extern u8 wifi_tx;              // WifiLED ̓_ŃXe[g

//############################################################################

//*****************************************************************************
void main( void ){
  // hdwinit( void );        // main()̑OɎŌĂ΂Ă܂B
  TM51_Start();                 // Cxg^C} W5msԊu

  // drcʏœdꂽ̂ //
  battLvl = 5;
  vregs[ REG_INT_ADRS_BATT_INFO ] = BATT_CO;
  vregs[ REG_INT_ADRS_MODE ]      = 0x20;
  set_batt_th();

  // C[v //
  while( 1 ){
    WDT_Restart();
    
    running_immediately();      // C^[o^C}OB荞݂ȂǋN //
    // C^[o^C}
    if( flg_interval ){         // 5msԊuŌĂ΂܂B̊荞݂ł܂킳Ȃ߁B
      flg_interval = 0;

      if( !system_inited ){
        wait_for_system_boot();
        // drc c Zbg܂łHiZ //
        
#ifdef debug_codes
        dbg_keyCheck();
#endif
      }else{
        if( adc_calib_mode != 0 ){ // ADC␳[hH
          tsk_adc_calib();      // T=4msɏĂ܂܂B
        }else{
          // ʏ^] //
#ifdef debug_codes
          pow_led_demo();
#endif
          running();
        }
      }
    }
    HALT();
  }
}



/******************************************************************************
  C^[ouĖĂ΂^XN
 ******************************************************************************/
void running(){
  static u8  mcu_mode_in_wake;

  // dXCb`EZbgǗ
  tsk_sw_pow();
  tsk_command_exec();

  // X[v/ȂJڎȂǂɂȂĂ͂Ȃ //
  if( ( PM_SLP == 0 ) && ( sleep_status != Wake ) ){
    // sleepwakeɑJڂƂB
    sleep_status = Wake;
    vregs[ REG_INT_ADRS_MODE ] = mcu_mode_in_wake; // ABꂢɏ
    PM_set_VRSET();       // twpwswƁAsleep̏ȓd͐ݒ
    set_camled();         // JLEDA
//    trig_to_wake_wifiLed();

  }else if( ( PM_SLP != 0 ) && ( sleep_status != Sleep ) ){
    // wakesleep
    sleep_status = Sleep;
    mcu_mode_in_wake = vregs[ REG_INT_ADRS_MODE ];
    vregs[ REG_INT_ADRS_MODE ] = 0;
    PM_set_VRSET();
    save_BL_param();
    set_camled_stop();
    trig_to_sleep_wifiLed();
  }

  // dLED //
  if( vregs[ REG_INT_ADRS_POWER_LED ] == 0 ){
    if( ++tsk_interval_cnt_power_led >= tsk_interval_power_led ){
      tsk_interval_cnt_power_led = 0;
      tsk_power_led();
    }
    led_pwm_GR_grad();
  }

  // WiFi LED //
  if( ++tsk_interval_cnt_wifi_led >= tsk_interval_wifi_led ){
    tsk_interval_cnt_wifi_led = 0;
    tsk_wifi_led();
  }

  // cam LED //
  if( ++tsk_interval_cnt_cam_led >= tsk_interval_cam_led ){
    tsk_interval_cnt_cam_led = 0;
    tsk_cam_led();
  }

  // /obNCgPxXCb`
  if( ++tsk_interval_cnt_sw_vol >= tsk_interval_sw_vol ){ // Ԋu
    tsk_interval_cnt_sw_vol = 0;
    tsk_sw_vol();
  }

  // drc //
  if( ++tsk_interval_cnt_adc >= tsk_interval_adc ){ //  ӁI@JE^ėpĂ܂I
    tsk_interval_cnt_adc = 0;
    tsk_adc();
  }

  // doffɁAwifi reset AT[g
  if( PM_OFF ){
    n_wifi_reset_ast;
  }
}



/******************************************************************************
  WX^݂ȂǂŋNwꂽ^XN
 ******************************************************************************/
void running_immediately(){
  // I2Cŏ܂ꂽƂB
  // ŏȂƁAL[łS/W I2C H/W I2CۂɃoXgpōB
  if( rsv_set_camLED ){
    rsv_set_camLED = 0;
    set_camled();
  }
  // akۑB@pmoff́Adr؂ꂻ
  // PM_OFF80msoB
  if( PM_OFF || ( battLvl <= 1 ) ){
    save_BL_param();
  }
  if( rsv_set_vol ){
    rsv_set_vol = 0;
    dcp_vol_set();
  }
  if( rsv_set_BL ){
    rsv_set_BL = 0;
    BL_write();
  }
  // NTR or TWLtw_pww2̒lς
  if( rsv_set_PMIC_VRSET ){
    rsv_set_PMIC_VRSET = 0;
    PM_set_VRSET();
  }
  // NANDی̊֌WŁAdrdõe[u؂ւ
  if( rsv_set_batt_th ){
    rsv_set_batt_th = 0;
    set_batt_th();
  }
  // LED_̂
  if( rsv_set_powLED ){
    rsv_set_powLED = 0;
    set_powLED_mode();
  }
}




/******************************************************************************
  N1b̓u[g[h
  Evol- ꂽ~[g
 ******************************************************************************/
void wait_for_system_boot(){
  if( !n_sys_reset ){
    // Zbg܂ŁAyxzs //
    if( ( n_key_func == 1 )
        && ( n_key_minus == 0 ) ){
      vol_mute_start = 1;
    }
  }else{
    // ZbgAy񂾂zs //
    iic2m_bus_reset();
    reg_init();               // zWX^̏l̃ZbgB(ɏlZbgĂȂ̓X^[gAbv[`őSNAj
    flash_init();
    restore_params();         // obNCgPxAADC␳lǂł
    if( vol_mute_start == 1 ){// mute?
      vregs[REG_INT_ADRS_VOL] = 0;
      dcp_vol_set();          // DCPւ̏݁A20msB̃ANZX
    }else{
      dcp_vol_read();         // {[ǂł
    }
    iic2m_bus_reset();
    pmic_init();              // dr擾ȂǁBZbg3ms͌oĂ͂...
    set_batt_th();
    IIC0_SlaveReceiveStart();
    system_inited = 1;
  }
}



/******************************************************************************
  L[̔BĂ΂ƂPオBT = 16ms ŌĂׂ΁A4sŃJXgƂȂB
  }N肷
 ******************************************************************************/
#define btn_check( btn, cntr ) { \
  if( btn == 0 ){                \
    if( cntr != 0xFF ){          \
      cntr++;                    \
    }                            \
  }else{                         \
    cntr = 0;                    \
  }                              \
}



/******************************************************************************
  {[/obNCgPxύX `FbN
 ******************************************************************************/
enum vol_or_bl { VOL, BL };

void tsk_sw_vol(){
  static u8 vol_mns_cntr, vol_pls_cntr;
  static u8 BL_mns_cntr,  BL_pls_cntr;

  if( n_key_func != 0 ){
    // VOL
    if( PM_SLP == 0 ){
      btn_check( n_key_plus, vol_pls_cntr ); // NĂȂ vol+ ͌Ȃ
    }else{
      vol_pls_cntr = 0;
    }
    BL_pls_cntr = 0;
    BL_mns_cntr = 0;
    
    btn_check( n_key_minus, vol_mns_cntr );
    if( n_key_plus == 0 && n_key_minus != 0 ){ // L[`FbN
      if( vol_pls_cntr == 1 ){
        tsk_interval_sw_vol = 2;
      }else if( vol_pls_cntr == 5 ){
        vol_inc();
      }else if( vol_pls_cntr >= 40 ){
        vol_inc();
        tsk_interval_sw_vol = 32;
      }
    }else if( n_key_plus != 0 && n_key_minus == 0 ){ // L[`FbN
      if( vol_mns_cntr == 1 ){
        tsk_interval_sw_vol = 2;
      }else if( vol_mns_cntr == 5 ){
        vol_dec();
      }else if( vol_mns_cntr >= 40 ){
        vol_dec();
        tsk_interval_sw_vol = 32;
      }
    }else{
      tsk_interval_sw_vol = 2;
    }
  }else{
    // funcĂƂFobNCgPx
    if( PM_SLP == 1 ){
      return;
    }
    vol_pls_cntr = 0;
    vol_mns_cntr = 0;

    btn_check( n_key_plus, BL_pls_cntr );
    btn_check( n_key_minus, BL_mns_cntr );
    if( n_key_plus == 0 && n_key_minus != 0 ){
      if( BL_pls_cntr == 1 ){
        tsk_interval_sw_vol = 2;
      }else if( BL_pls_cntr == 5 ){
        BL_inc();
      }else if( BL_pls_cntr >= 40 ){
        BL_inc();
        tsk_interval_sw_vol = 32;
      }
    }else if( n_key_plus != 0 && n_key_minus == 0 ){
      if( BL_mns_cntr == 1 ){
        tsk_interval_sw_vol = 2;
      }else if( BL_mns_cntr == 5 ){
        BL_dec();
      }else if( BL_mns_cntr >= 40 ){
        BL_dec();
        tsk_interval_sw_vol = 32;
      }
    }else{
      tsk_interval_sw_vol = 2;
    }
  }
}



/******************************************************************************
 PjdXCb`̃JEgA
@@@TWLƁANDSŋႢ܂
@@@`^O͊OłĂĂ܂(20ms)
 QjhQbŃR}hꂽƂ̓
 I@jς܂B
@@@ENTR̂ƂAoffPMICɔC܂B
@@@E܂܃X[v畜A痣܂Ŗ͂܂BA@ł͂Ȃ
 ******************************************************************************/
void tsk_sw_pow(){
  static u8 rst_cntr;
  
/*
  if( PM_SLP == 1 ){          // X[v͓
      pwsw_state = 3;           // ܂܃X[v畜AȂA܂ŖtO
      return;
  }
*/
  
  if( n_key_pwsw == 0 ){ 
    /// Ă ///
    if( rst_cntr != 255 ){
      rst_cntr++;
    }
    
    if( ( pwsw_state == 0 ) &&
        ( rst_cntr >= vregs[ REG_INT_ADRS_TIME_PWSW_DELAY ] ) ){ // Ԍo߁H
      pwsw_state = 1;
      if( is_TWL ){
//        DI();
        vregs[REG_INT_ADRS_IRQ] |= 0x08;
        n_irq_ast;
        n_irq_ngt;
//        EI();
      }else{
        // Ȃ
      }
      return;
    }
    if( ( pwsw_state == 1 ) &&
        ( rst_cntr >= vregs[ REG_INT_ADRS_TIME_PWSW_THRESHOLD ] ) ){ // dItm
      pwsw_state = 2;         // /IRQ ܂Ȃ悤
      if( is_TWL ){
//        DI();
        vregs[REG_INT_ADRS_IRQ] |= 0x02;
        n_irq_ast;
        n_irq_ngt;
//        EI();
      }else{
        // Ȃ
      }
      return;
    }
    return;                     // ȍ~XCb`
  }else{
    /// Ă ///
    if( pwsw_state == 1 ){      // Zbgm
      if( is_TWL ){
//        DI();
        vregs[REG_INT_ADRS_IRQ] |= 0x01;
        n_irq_ast;
        n_irq_ngt;
//        EI();
      }else{
        vregs[REG_INT_ADRS_COMMAND] |= 0x01;
      }
    }
    rst_cntr   = 0;
    pwsw_state = 0;
  }
}



/******************************************************************************
 hQbŃR}hꂽƂ̉߂ƁAnȂ
 ******************************************************************************/
void tsk_command_exec(){
  static u8 count;

  // WX^`FbN //
  if( ( vregs[ REG_INT_ADRS_COMMAND ] & 0x02 ) != 0 ){ // dIt
    // Iɂ͓dItR}h𑗂...
  }else if( ( vregs[ REG_INT_ADRS_COMMAND ] & 0x01 ) != 0 ){ // Zbg
    n_sys_reset_ast;
  }

  // Zbg{^ //
  if( n_sys_reset == 0 ){
    if( count < 2 ){
      count++;
    }else{
      vregs[ REG_INT_ADRS_IRQ ]        = 0;
      vregs[ REG_INT_ADRS_COMMAND ]    = 0;
      vregs[ REG_INT_ADRS_CAM ]        = 0;
      set_camled_stop();
      vregs[ REG_INT_ADRS_MODE ]       = 0;
      //  volSteps32 = 0
      //    is_TWL = 0
      //    with_NAND = 0
      vregs[ REG_INT_ADRS_POWER_SAVE ] = 0x07;
      set_batt_th();
      rsv_set_PMIC_VRSET = 1;
      if( vregs[ REG_INT_ADRS_POWER_LED ] != 0 ){
        vregs[ REG_INT_ADRS_POWER_LED ] = 0;
        set_powLED_mode();
      }
      wifi_tx = 0;
      n_irq_ngt;
      n_sys_reset_ngt;
      EI();
      pwsw_state = 3;
    }
  }else{
    count = 0;
  }
}



/******************************************************************************
 obNCgPxۑ
  sleep or PM_OFF Amsq[hœdrȂ瑦L^B
 ******************************************************************************/
void save_BL_param(){
  u8 status;

  if( eeprom_bl_dirty == 1 ){
    if( flash_write( DAT_BL_BRIGHT, &vregs[REG_INT_ADRS_BL] ) == 0 ){
      eeprom_bl_dirty = 0;
    }
  }
}



void SystemInit( void ){
  CG_ReadResetSource();         /*Process of reset*/
  Clock_Init();                 /*initialize the clock generator*/
  PORT_Init();                  /*Initialize the I/O ports*/
  IIC0_Init();                  /*Initialize the IIC0*/
  ADC_Init();
  TM51_Init();                  /*Initialize TM51 function*/

  TMH0_Init();                  /*Initialize TMH0 function*/
  TMH1_Init();                  /*Initialize TMH1 function*/
  TM50_Init();                  /*Initialize TM50 function*/
}



void hdwinit( void ){
  DI();
  IMS = MEMORY_IMS_SET;
  SystemInit();
  EI();
}


void reg_init(){
#ifdef after_x6
  // Ver.3(TWL,X6ȍ~(RxPEĎ), Rev.0(ȏΉ)
  //                                     1(Func + +/- )
  vregs[ REG_INT_ADRS_VER_INFO ]   = 0x33;
#else
  // Ver.2(TWL), Rev.1(K,TS-X4ȍ~)
  // Ver.2(TWL), Rev.2(ȏΉ)
  vregs[ REG_INT_ADRS_VER_INFO ]   = 0x25;
#endif
  vregs[ REG_INT_ADRS_POWER_SAVE ] = 0x07;
  vregs[ REG_INT_ADRS_TIME_PWSW_DELAY ]     = (  80 ) / 5;
  vregs[ REG_INT_ADRS_TIME_PWSW_THRESHOLD ] = ( 500 ) / 5;

#ifdef wifi_led_blink_default_on
  // `[Ή҂AWiFiLEDuNftHgON
  vregs[ REG_INT_ADRS_WIFI ] = 0x02;
#endif
  
}
