#ifndef __PMIC_TWL2_H__
#define __PMIC_TWL2_H__

#include "jhl_defs.h"

#define IIC_SLV_ADDR_PMIC 0x82

enum PMIC_REG_ADRS{
  PMIC_REG_ADRS_VR_INF = 0x00,
  PMIC_REG_ADRS_VR_SET,
  PMIC_REG_ADRS_BT_CHK,
  PMIC_REG_ADRS_BL_BRT
};


void pmic_init();
void BL_inc();
void BL_dec();
void BL_write();
void PM_set_VRSET();

#endif
