/******************************************************************************
  \tgEFAI2CʐM
    de JHL cJZ
    '07 Aug, '07 Dec

  IIӁII
  Eǂݏo݂s (vol inc/dec) 悻1ms܂B
  ENbÑf[eB[ȂǂvȂłB
  E荞݋֎~ɂĂȂ̂Ń^C~OɂĂ͊荞݂܂B
  Eg`̑Ώ̐ȂǋCɂĂ܂BőŃp^p^܂AƂƒxłB
  EEFCgRfBVƂ肠Cɂ܂B
  EʐM̃ZbgAbv^CCɂɓǂ݂ɍs܂BłƂƒxłi悻1.2usjB
  EʐMɊ荞݂ȂǂłɒʐMJn邱Ƃz肵Ă܂B
  @irobt@Ŏ󂯂肵܂jȂłB
*******************************************************************************/
#include "macrodriver.h"
#include "port.h"
#include "user_define.h"
#include "SW_I2C.h"

#define iics_sda_H           PM1.1 = 1
#define iics_sda_L           { P1.1 = 0; PM1.1 = 0; }
#define iics_scl_H           PM1.0 = 1
#define iics_scl_L           { P1.0 = 0; PM1.0 = 0; }
#define iics_sda             P1.1
#define iics_scl             P1.0


#define iic2m_send_start   { iics_sda_H; iics_scl_H; iics_sda_L; iics_scl_L; }
#define iic2m_send_stop_0  { iics_sda_L; iics_scl_H; }
// ŃEFCgRfBV`FbN //
#define iic2m_send_stop_1  { iics_sda_H; }
#define iic2m_send_stop    { iic2m_send_stop_0; iic2m_send_stop_1; }

#define iic2m_send_nack    { iics_sda_H; iics_scl_H; iics_scl_H; iics_scl_L; }

/******************************************************************************
 * X[uAhXAhX slv_adrs ́AWX^ adrs (1oCg)Ԃ܂B@
 * [hG[ƂPA܂B댯B
 ******************************************************************************/
u8 iic2m_read_byte( u8 slv_adrs, u8 adrs ){
  u8 b, tmp;

  iic2m_send_start;
  if( iic2m_w_byte( slv_adrs | 0x00 ) != 0x00 ){ // X[uAhX
    iic2m_send_stop;
    return( 0x5A );
  }
  iic2m_w_byte( adrs );
  
  iic2m_send_start;
  if( iic2m_w_byte( slv_adrs | 0x01 ) != 0x00 ){ // X[uAhX
    iic2m_send_stop;
    return( 0xA5 );
  }
  // [h
  iics_sda_H;
  for( b = 0; b != 8; b++ ){
    tmp <<= 1;
    iics_scl_H;
    if( iics_sda != 0 ){
      tmp |= 0x01;
    }
    iics_scl_L;
  }
  iic2m_send_nack;              // ŏIoCgNACKԂB
  iic2m_send_stop;
  return tmp;
}


/******************************************************************************
 * X[uAhXAhX slv_adrs ́AWX^ adrs ɂPoCg܂B
 * X[uĂяoNACKȂA0xFFŒfIłB
 ******************************************************************************/
unsigned char iic2m_write_data( u8 slv_adrs, u8 adrs, u8 dat ){
  u8 status;
  
  iic2m_send_start;
  if( iic2m_w_byte( slv_adrs | 0x00 ) != 0x00 ){ // X[uAhX
    iic2m_send_stop;
    return( 0xFF );
  }
  iic2m_w_byte( adrs );            // WX^AhX
  iic2m_w_byte( dat );             // f[^1oCg
  iic2m_send_stop;
  return( 0 );
}


#if 0
gpł
/******************************************************************************
 * X[uAhXAhX slv_adrs ́A
 * WX^ adrs 擪ɁA
 * *str
 * len܂B
 * G[ƂPA܂B댯B
 ******************************************************************************/
void iic2m_write_nmem( u8 slv_adrs, u8 adrs, s8* str, u8 len ){
  u8 i;

  iic2m_send_start;
  iic2m_w_byte( slv_adrs | 0x00 );
  iic2m_w_byte( adrs );
  for( i = 0; i < len; i++ ){
    iic2m_w_byte( *str );
    str++;
  }
  /*
  while( *str != "\0" ){
    iic2m_w_byte( *str );
    str++;
  }
  */
  iic2m_send_stop;
}
#endif


/******************************************************************************
  oX̃Zbg
  XgbvRfBVo炷oB
 ******************************************************************************/
void iic2m_bus_reset(){
  u8 count;

  for( count = 19; count != 0; count-- ){
    iics_sda_H;
    iics_scl_H;
    PM1.1 = 1;                  // SDA
    if( iics_sda != 0 ){
      PM1.1 = 0;
      iic2m_send_stop;
      return;
    }
    PM1.1 = 0;
    iics_scl_L;
  }
  return;
}


/******************************************************************************
  hQbP@\`oh
  قƂɂPoCg
 ******************************************************************************/
static unsigned char iic2m_w_byte( unsigned char dat ){
  unsigned char b;
  unsigned int tot;

  // 8bitXɂ܂B
  for( b = 0; b != 8; b++ ){
    if( ( dat & 0b10000000 ) != 0 ){
      iics_sda_H;
    }else{
      iics_sda_L;
    }
    iics_scl_H;
    dat <<= 1;  // łɎԉ҂BAZuȂƏɏ̂ɁI
    iics_scl_L;
  }
  iics_sda_H;
  iics_scl_H;

#ifdef enable_swi2c_wait
  tot = 0;
  while( iics_scl == 0 ){
    // EFCgRfBV
    //  ܂߂ɂƃ^CAEgƂǂ悤ƂAX[u
    //  oXJĂȂȂASfoCXƒʐMłȂƂ
    if( ++tot > 10000 ){
      iics_scl_L;
      return( 0xFE );
    }
  }
#endif

  if( iics_sda != 0 ){
    // NACK
    iics_scl_L;
    return( 0xFF );
  }
  iics_scl_L;
  return( 0 );
}

